unit FormMain;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, ExtCtrls, StdCtrls, CheckLst, Automaton, atmSlotMachine,
  Buttons, ImgList, JvxAnimate, JvGIFCtrl;

type
  TSlotMachine = class(TForm)
    TimerSync1: TTimer;
    Panel1: TPanel;
    Barrel1: TJvGIFAnimator;
    Barrel2: TJvGIFAnimator;
    Barrel3: TJvGIFAnimator;
    Log: TMemo;
    cbA0LogSettings: TCheckListBox;
    TimerB1: TTimer;
    TimerB2: TTimer;
    TimerB3: TTimer;
    JackTimer: TTimer;
    Label1: TLabel;
    Label2: TLabel;
    cbA1LogSettings: TCheckListBox;
    Label3: TLabel;
    cbA2LogSettings: TCheckListBox;
    edBank: TEdit;
    Label4: TLabel;
    Image1: TImage;
    Image2: TImage;
    Image3: TImage;
    Image4: TImage;
    Image5: TImage;
    Image6: TImage;
    Image7: TImage;
    Image8: TImage;
    Image9: TImage;
    Image10: TImage;
    Image11: TImage;
    Image12: TImage;
    Image13: TImage;
    Image14: TImage;
    Image15: TImage;
    Image16: TImage;
    Image17: TImage;
    Image18: TImage;
    Image19: TImage;
    Image20: TImage;
    Image21: TImage;
    Image22: TImage;
    Image23: TImage;
    Image24: TImage;
    Image25: TImage;
    Image26: TImage;
    Image27: TImage;
    Image28: TImage;
    Image29: TImage;
    Image30: TImage;
    Image31: TImage;
    Image32: TImage;
    Image33: TImage;
    Image34: TImage;
    Image35: TImage;
    Image36: TImage;
    Image37: TImage;
    Image38: TImage;
    Image39: TImage;
    Image40: TImage;
    Image41: TImage;
    Image42: TImage;
    Image43: TImage;
    Image44: TImage;
    Image45: TImage;
    Image46: TImage;
    Image47: TImage;
    Image48: TImage;
    Image49: TImage;
    Image50: TImage;
    Image51: TImage;
    Image52: TImage;
    Image53: TImage;
    Image54: TImage;
    Image55: TImage;
    Image56: TImage;
    Image57: TImage;
    Image58: TImage;
    Image59: TImage;
    Image60: TImage;
    Image61: TImage;
    Image62: TImage;
    Image63: TImage;
    Image64: TImage;
    Image65: TImage;
    Image66: TImage;
    Image67: TImage;
    Image68: TImage;
    Image69: TImage;
    Image70: TImage;
    Image71: TImage;
    Image72: TImage;
    Image73: TImage;
    Image74: TImage;
    Image75: TImage;
    Image76: TImage;
    Image77: TImage;
    Image78: TImage;
    Image79: TImage;
    Image80: TImage;
    Image81: TImage;
    Image82: TImage;
    Image83: TImage;
    Image84: TImage;
    Image85: TImage;
    Image86: TImage;
    Image87: TImage;
    Image88: TImage;
    Image89: TImage;
    Image90: TImage;
    Image91: TImage;
    Image92: TImage;
    Image93: TImage;
    Image94: TImage;
    Image95: TImage;
    Image96: TImage;
    Image97: TImage;
    Image98: TImage;
    Image99: TImage;
    Image100: TImage;
    Shape1: TShape;
    Label5: TLabel;
    edStake: TEdit;
    TimerSync2: TTimer;
    TimerSync3: TTimer;
    edJackPot: TEdit;
    Label6: TLabel;
    iBadCoin: TImage;
    btnTechReset: TSpeedButton;
    iPlay: TJvGIFAnimator;
    iReturn: TJvGIFAnimator;
    procedure FormCreate(Sender: TObject);
    procedure cbA0LogSettingsClickCheck(Sender: TObject);
    procedure cbA1LogSettingsClickCheck(Sender: TObject);
    procedure cbA2LogSettingsClickCheck(Sender: TObject);
    procedure Image1Click(Sender: TObject);
    procedure iReturnClick(Sender: TObject);
    procedure iPlayClick(Sender: TObject);
    procedure TimerSync2Timer(Sender: TObject);
    procedure TimerSync3Timer(Sender: TObject);
    procedure TimerB1Timer(Sender: TObject);
    procedure TimerB2Timer(Sender: TObject);
    procedure TimerB3Timer(Sender: TObject);
    procedure TimerSync1Timer(Sender: TObject);
    procedure JackTimerTimer(Sender: TObject);
    procedure iBadCoinClick(Sender: TObject);
    procedure btnTechResetClick(Sender: TObject);
    procedure FormDestroy(Sender: TObject);
  private
    AutomatonsDispatcher: TAutomatonsDispatcher;
    A0:                   TAutomatonSlotMachine;
    A1:                   TAutomatonMoneyTray;
    A2:                   TAutomatonBarrelsEngine;
  public
    BankCoinsCount:    integer;
    UserCoinsCount:    integer;
    JackPotCoinsCount: integer;
    Stake:             integer;
    IsTrayClosed:      boolean;
    CoinOK:            boolean;
  public
    procedure MoneyTrayEnable(enable: boolean);
    procedure PayFromBank();
    function  IsCoinOK(): boolean;
    procedure RecieveMoney();
    procedure ReturnMoney();
    procedure SetJackPot();

    procedure UpdateCoinImages();
  end;

var
  SlotMachine: TSlotMachine;

implementation

{$R *.dfm}

function GetBarrelNumber(Barrel: TJvGIFAnimator): integer;
begin
  if (Barrel.FrameIndex > 0) and (Barrel.FrameIndex < 4) or
     (Barrel.FrameIndex >= 57) and (Barrel.FrameIndex <= 60)
        then begin result := 1;  Barrel.FrameIndex := 60; end else

  if (Barrel.FrameIndex >= 4) and (Barrel.FrameIndex < 11)
        then begin result := 2; Barrel.FrameIndex := 7; end else

  if (Barrel.FrameIndex >= 11) and (Barrel.FrameIndex <= 16)
        then begin result := 3; Barrel.FrameIndex := 14; end else

  if (Barrel.FrameIndex > 16) and (Barrel.FrameIndex < 24)
        then begin result := 4; Barrel.FrameIndex := 21; end else

  if (Barrel.FrameIndex >= 24) and (Barrel.FrameIndex <= 30)
        then begin result := 5; Barrel.FrameIndex := 27; end else

  if (Barrel.FrameIndex >=30) and (Barrel.FrameIndex <= 37)
        then begin result := 6; Barrel.FrameIndex := 34; end else

  if (Barrel.FrameIndex >37) and (Barrel.FrameIndex < 43)
        then begin result := 7; Barrel.FrameIndex := 40; end else

  if (Barrel.FrameIndex >43) and (Barrel.FrameIndex < 50)
        then begin result := 8; Barrel.FrameIndex := 47; end

  else
        begin result := 9; Barrel.FrameIndex := 54; end;
end;

procedure TSlotMachine.FormCreate(Sender: TObject);
var
  i:integer;
begin
  IsTrayClosed:=false;
  BankCoinsCount := 50;
  UserCoinsCount := 50;
  CoinOK := true;
  UpdateCoinImages;

  Randomize;

  AutomatonsDispatcher := TAutomatonsDispatcher.Create();
  A0 := TAutomatonSlotMachine.Init   (0, ' ');
  A1 := TAutomatonMoneyTray.Init     (1, '');
  A2 := TAutomatonBarrelsEngine.Init (2, ' ');

  Barrel1.FrameIndex := 40;
  Barrel2.FrameIndex := 40;
  Barrel3.FrameIndex := 40;

  cbA0LogSettings.Checked[0]:=true; A0.LogWake := true;
  cbA0LogSettings.Checked[1]:=true; A0.LogStateChange := true;
  cbA0LogSettings.Checked[2]:=true; A0.LogSleep:= true;

  cbA1LogSettings.Checked[0]:=true; A1.LogWake := true;
  cbA1LogSettings.Checked[1]:=true; A1.LogStateChange := true;
  cbA1LogSettings.Checked[2]:=true; A1.LogSleep:= true;

  cbA2LogSettings.Checked[0]:=true; A2.LogWake := true;
  cbA2LogSettings.Checked[1]:=true; A2.LogStateChange := true;
  cbA2LogSettings.Checked[2]:=true; A2.LogSleep:= true;

  AutomatonsDispatcher.AddAutomaton(A0);
  AutomatonsDispatcher.AddAutomaton(A1);
  AutomatonsDispatcher.AddAutomaton(A2);

  AutomatonsDispatcher.y[0].Add('');
  AutomatonsDispatcher.y[0].Add(' ');
  AutomatonsDispatcher.y[0].Add('');
  AutomatonsDispatcher.y[0].Add('');
  AutomatonsDispatcher.y[0].Add(' ');

  AutomatonsDispatcher.y[1].Add(' ');
  AutomatonsDispatcher.y[1].Add(' ');
  AutomatonsDispatcher.y[1].Add('  ');

  AutomatonsDispatcher.y[2].Add(' ');
  AutomatonsDispatcher.y[2].Add(' ');
  AutomatonsDispatcher.y[2].Add('  ');
  AutomatonsDispatcher.y[2].Add('  ');

  for i:=0 to 23 do
    AutomatonsDispatcher.e.Add('');

  AutomatonsDispatcher.e[0]  := '(  0):  ';
  AutomatonsDispatcher.e[22] := '   ';
  AutomatonsDispatcher.e[23] := '   ';
  AutomatonsDispatcher.e[5]  := '   ';
  AutomatonsDispatcher.e[1]  := '  ''''';
  AutomatonsDispatcher.e[2]  := '  '' ''';
  AutomatonsDispatcher.e[3]  := '  ''. ''';
  AutomatonsDispatcher.e[6]  := '   ';
  AutomatonsDispatcher.e[10] := ' ';
  AutomatonsDispatcher.e[11] := '(  A1)  ';
  AutomatonsDispatcher.e[12] := '(  A0)    ';
  AutomatonsDispatcher.e[12] := '(  A0)    ';
end;

procedure TSlotMachine.MoneyTrayEnable(enable: boolean);
begin
  IsTrayClosed := not enable;
  if (IsTrayClosed) then
    Shape1.Brush.Style := bsDiagCross
  else
    Shape1.Brush.Style := bsSolid;
end;

procedure TSlotMachine.PayFromBank();
begin
    dec(BankCoinsCount);
    dec(JackPotCoinsCount);
    inc(UserCoinsCount);
    JackTimer.Interval := 250;
end;

function TSlotMachine.IsCoinOK(): boolean;
begin
  result := coinOK;
end;

procedure TSlotMachine.RecieveMoney();
begin
  BankCoinsCount := BankCoinsCount + Stake;
end;

procedure TSlotMachine.ReturnMoney();
begin
    UserCoinsCount := UserCoinsCount + Stake;
    Stake := 0;
    coinOK := true;
    UpdateCoinImages;
end;

procedure TSlotMachine.SetJackPot();
var
  b1: integer;
  b2: integer;
  b3: integer;
begin
  b1 := GetBarrelNumber(Barrel1);
  b2 := GetBarrelNumber(Barrel2);
  b3 := GetBarrelNumber(Barrel3);

  if (b1 = b2) and (b2 = b3) then
  begin
	if (b1 = 7) then JackPotCoinsCount := 10*Stake
 			    else JackPotCoinsCount := 5*Stake;
  end
  else if (b1+1 = b2) and (b2+1 = b3)			then JackPotCoinsCount := 7*Stake
  else if (b1 = b2) or (b3 = b2) or (b3 = b2) 	then JackPotCoinsCount := 4*Stake
  else if (b1 = 7) 								then JackPotCoinsCount := stake + 1
  else if (b1 div 2 <> 0) 						then JackPotCoinsCount := 1
  else
    JackPotCoinsCount := 0;

end;

procedure TSlotMachine.cbA0LogSettingsClickCheck(Sender: TObject);
begin
  A0.LogWake        := cbA0LogSettings.Checked[0];
  A0.LogStateChange := cbA0LogSettings.Checked[1];
  A0.LogSleep       := cbA0LogSettings.Checked[2];
  A0.LogInput       := cbA0LogSettings.Checked[3];
  A0.LogOutput      := cbA0LogSettings.Checked[4];
end;

procedure TSlotMachine.cbA1LogSettingsClickCheck(Sender: TObject);
begin
  A1.LogWake        := cbA1LogSettings.Checked[0];
  A1.LogStateChange := cbA1LogSettings.Checked[1];
  A1.LogSleep       := cbA1LogSettings.Checked[2];
  A1.LogInput       := cbA1LogSettings.Checked[3];
  A1.LogOutput      := cbA1LogSettings.Checked[4];
end;

procedure TSlotMachine.cbA2LogSettingsClickCheck(Sender: TObject);
begin
  A2.LogWake        := cbA2LogSettings.Checked[0];
  A2.LogStateChange := cbA2LogSettings.Checked[1];
  A2.LogSleep       := cbA2LogSettings.Checked[2];
  A2.LogInput       := cbA2LogSettings.Checked[3];
  A2.LogOutput      := cbA2LogSettings.Checked[4];
end;

procedure TSlotMachine.Image1Click(Sender: TObject);
begin
  if (UserCoinsCount<>0) and not IsTrayClosed then
  begin
    coinOK := true;
    UserCoinsCount := UserCoinsCount - 1;
    Stake          := Stake + 1;
    A1.Wake(10);
    UpdateCoinImages;
  end;
end;

procedure TSlotMachine.UpdateCoinImages();
begin
  Image1.Visible := UserCoinsCount >= 1;
  Image2.Visible := UserCoinsCount >= 2;
  Image3.Visible := UserCoinsCount >= 3;
  Image4.Visible := UserCoinsCount >= 4;
  Image5.Visible := UserCoinsCount >= 5;
  Image6.Visible := UserCoinsCount >= 6;
  Image7.Visible := UserCoinsCount >= 7;
  Image8.Visible := UserCoinsCount >= 8;
  Image9.Visible := UserCoinsCount >= 9;

  Image10.Visible := UserCoinsCount >= 10;
  Image11.Visible := UserCoinsCount >= 11;
  Image12.Visible := UserCoinsCount >= 12;
  Image13.Visible := UserCoinsCount >= 13;
  Image14.Visible := UserCoinsCount >= 14;
  Image15.Visible := UserCoinsCount >= 15;
  Image16.Visible := UserCoinsCount >= 16;
  Image17.Visible := UserCoinsCount >= 17;
  Image18.Visible := UserCoinsCount >= 18;
  Image19.Visible := UserCoinsCount >= 19;

  Image20.Visible := UserCoinsCount >= 20;
  Image21.Visible := UserCoinsCount >= 21;
  Image22.Visible := UserCoinsCount >= 22;
  Image23.Visible := UserCoinsCount >= 23;
  Image24.Visible := UserCoinsCount >= 24;
  Image25.Visible := UserCoinsCount >= 25;
  Image26.Visible := UserCoinsCount >= 26;
  Image27.Visible := UserCoinsCount >= 27;
  Image28.Visible := UserCoinsCount >= 28;
  Image29.Visible := UserCoinsCount >= 29;

  Image30.Visible := UserCoinsCount >= 30;
  Image31.Visible := UserCoinsCount >= 31;
  Image32.Visible := UserCoinsCount >= 32;
  Image33.Visible := UserCoinsCount >= 33;
  Image34.Visible := UserCoinsCount >= 34;
  Image35.Visible := UserCoinsCount >= 35;
  Image36.Visible := UserCoinsCount >= 36;
  Image37.Visible := UserCoinsCount >= 37;
  Image38.Visible := UserCoinsCount >= 38;
  Image39.Visible := UserCoinsCount >= 39;

  Image40.Visible := UserCoinsCount >= 40;
  Image41.Visible := UserCoinsCount >= 41;
  Image42.Visible := UserCoinsCount >= 42;
  Image43.Visible := UserCoinsCount >= 43;
  Image44.Visible := UserCoinsCount >= 44;
  Image45.Visible := UserCoinsCount >= 45;
  Image46.Visible := UserCoinsCount >= 46;
  Image47.Visible := UserCoinsCount >= 47;
  Image48.Visible := UserCoinsCount >= 48;
  Image49.Visible := UserCoinsCount >= 49;

  Image50.Visible := UserCoinsCount >= 50;
  Image51.Visible := UserCoinsCount >= 51;
  Image52.Visible := UserCoinsCount >= 52;
  Image53.Visible := UserCoinsCount >= 53;
  Image54.Visible := UserCoinsCount >= 54;
  Image55.Visible := UserCoinsCount >= 55;
  Image56.Visible := UserCoinsCount >= 56;
  Image57.Visible := UserCoinsCount >= 57;
  Image58.Visible := UserCoinsCount >= 58;
  Image59.Visible := UserCoinsCount >= 59;

  Image60.Visible := UserCoinsCount >= 60;
  Image61.Visible := UserCoinsCount >= 61;
  Image62.Visible := UserCoinsCount >= 62;
  Image63.Visible := UserCoinsCount >= 63;
  Image64.Visible := UserCoinsCount >= 64;
  Image65.Visible := UserCoinsCount >= 65;
  Image66.Visible := UserCoinsCount >= 66;
  Image67.Visible := UserCoinsCount >= 67;
  Image68.Visible := UserCoinsCount >= 68;
  Image69.Visible := UserCoinsCount >= 69;

  Image70.Visible := UserCoinsCount >= 70;
  Image71.Visible := UserCoinsCount >= 71;
  Image72.Visible := UserCoinsCount >= 72;
  Image73.Visible := UserCoinsCount >= 73;
  Image74.Visible := UserCoinsCount >= 74;
  Image75.Visible := UserCoinsCount >= 75;
  Image76.Visible := UserCoinsCount >= 76;
  Image77.Visible := UserCoinsCount >= 77;
  Image78.Visible := UserCoinsCount >= 78;
  Image79.Visible := UserCoinsCount >= 79;

  Image80.Visible := UserCoinsCount >= 80;
  Image81.Visible := UserCoinsCount >= 81;
  Image82.Visible := UserCoinsCount >= 82;
  Image83.Visible := UserCoinsCount >= 83;
  Image84.Visible := UserCoinsCount >= 84;
  Image85.Visible := UserCoinsCount >= 85;
  Image86.Visible := UserCoinsCount >= 86;
  Image87.Visible := UserCoinsCount >= 87;
  Image88.Visible := UserCoinsCount >= 88;
  Image89.Visible := UserCoinsCount >= 89;

  Image90.Visible := UserCoinsCount >= 90;
  Image91.Visible := UserCoinsCount >= 91;
  Image92.Visible := UserCoinsCount >= 92;
  Image93.Visible := UserCoinsCount >= 93;
  Image94.Visible := UserCoinsCount >= 94;
  Image95.Visible := UserCoinsCount >= 95;
  Image96.Visible := UserCoinsCount >= 96;
  Image97.Visible := UserCoinsCount >= 97;
  Image98.Visible := UserCoinsCount >= 98;
  Image99.Visible := UserCoinsCount >= 99;

  Image100.Visible := UserCoinsCount >= 100;

  iBadCoin.Visible := coinOK;
end;

procedure TSlotMachine.iReturnClick(Sender: TObject);
begin
  A0.Wake(2);
  UpdateCoinImages;
end;

procedure TSlotMachine.iPlayClick(Sender: TObject);
begin
  A0.Wake(1);
end;

procedure TSlotMachine.TimerSync1Timer(Sender: TObject);
begin
 if (Barrel1.FrameIndex = 60)
    then Barrel1.FrameIndex := 1
  else
    Barrel1.FrameIndex := Barrel1.FrameIndex + 1;
end;

procedure TSlotMachine.TimerSync2Timer(Sender: TObject);
begin
  if (Barrel2.FrameIndex = 60)
    then Barrel2.FrameIndex := 1
  else
    Barrel2.FrameIndex := Barrel2.FrameIndex + 1;
end;

procedure TSlotMachine.TimerSync3Timer(Sender: TObject);
begin
  if (Barrel3.FrameIndex = 60)
    then Barrel3.FrameIndex := 1
  else
    Barrel3.FrameIndex := Barrel3.FrameIndex + 1;
end;

procedure TSlotMachine.TimerB1Timer(Sender: TObject);
begin
  TimerB1.Interval := 0;
  TimerSync1.Interval := 0;
  GetBarrelNumber(Barrel1);
  A2.Wake(22);
end;

procedure TSlotMachine.TimerB2Timer(Sender: TObject);
begin
  TimerB2.Interval := 0;
  TimerSync2.Interval := 0;
  GetBarrelNumber(Barrel2);
  A2.Wake(23);
end;

procedure TSlotMachine.TimerB3Timer(Sender: TObject);
begin
  TimerB3.Interval := 0;
  TimerSync3.Interval := 0;
  GetBarrelNumber(Barrel3);
  A0.Wake(5);
end;

procedure TSlotMachine.JackTimerTimer(Sender: TObject);
begin
  if ((BankCoinsCount = 0) or (JackPotCoinsCount = 0))
    then
      JackTimer.Interval := 0;
  A0.Wake(6);
  UpdateCoinImages;
end;

procedure TSlotMachine.iBadCoinClick(Sender: TObject);
begin
  if not IsTrayClosed then
  begin
    coinOK := false;
    A1.Wake(10);
    UpdateCoinImages;
  end;
end;

procedure TSlotMachine.btnTechResetClick(Sender: TObject);
begin
  A0.Wake(3);
end;

procedure TSlotMachine.FormDestroy(Sender: TObject);
begin
  AutomatonsDispatcher.Free;
end;

end.

